function [OutputI OutputII]=LI2DCHChekerboard(x1,x2,d1,d2,epsilona,epsilonb,M1,N1)
%% First Inverse rule and then Laurent rule
%% OutputI  : inverse in x1 and the Laurent in x2 direction
%% OutputII : inverse in x2 and the Laurent in x1 direction
%% 920426
q=sqrt(-1);    
M=M1;
N=N1;
l1=x1(1);
l3=x1(2);
l5=x1(3);
l2=x2(1);
l4=x2(2);
l6=x2(3);

% This computes the Eq # 8 of Li 1997 for checkerboard grating.
A1=FC1DCH(l1,l3,l5,d1,epsilona,epsilonb,M);  % Eq # 6 of Li 1997 for checkerboard grating.
A1=inv(A1);
A2=FC1DCH(l1,l3,l5,d1,epsilonb,epsilona,M);   % Eq # 6 of Li 1997 for checkerboard grating.
A2=inv(A2);
OutputI=zeros((2*M+1)*(2*N+1),(2*M+1)*(2*N+1));
k=0;
for m=-M:M
    for n=-N:N
        k=k+1;
        h=0;
        for j=-M:M
            for l=-N:N
                h=h+1;
                if n==l
                    OutputI(k,h)=A1(m+M+1,j+M+1)*(l4-l2)/d2+A2(m+M+1,j+M+1)*(l6-l4)/d2;
                else
                    OutputI(k,h)=A1(m+M+1,j+M+1)*(exp(-q*2*pi*(n-l)*l4/d2)-exp(-q*2*pi*(n-l)*l2/d2))/(-2*q*pi*(n-l))+A2(m+M+1,j+M+1)*(exp(-q*2*pi*(n-l)*l6/d2)-exp(-q*2*pi*(n-l)*l4/d2))/(-2*q*pi*(n-l));
                end 
            end
        end
    end
end

% clear A1;
% clear A2;
% % This computes the Eq # 9 of Li 1997 for checkerboard grating
% A1=FC1DCH(l2,l4,l6,d2,epsilona,epsilonb,N);   % Eq # 7 of Li 1997 for checkerboard grating.
% A1=inv(A1);
% A2=FC1DCH(l2,l4,l6,d2,epsilonb,epsilona,N);   % Eq # 7 of Li 1997 for checkerboard grating.
% A2=inv(A2);
OutputII=zeros((2*M+1)*(2*N+1),(2*M+1)*(2*N+1));
k=0;
for m=-M:M
    for n=-N:N
        k=k+1;
        h=0;
        for j=-M:M
            for l=-N:N
                h=h+1;
                if m==j
                    OutputII(k,h)=A1(n+N+1,l+N+1)*(l3-l1)/d1+A2(n+N+1,l+N+1)*(l5-l3)/d1;
                else
                    OutputII(k,h)=A1(n+N+1,l+N+1)*(exp(-q*2*pi*(m-j)*l3/d2)-exp(-q*2*pi*(m-j)*l1/d2))/(-2*q*pi*(m-j))+A2(n+N+1,l+N+1)*(exp(-q*2*pi*(m-j)*l5/d1)-exp(-q*2*pi*(m-j)*l3/d1))/(-2*q*pi*(m-j));
                end
            end
        end
    end
end

function Output=FC1DCH(l1,l3,l5,d1,epsilon1,epsilon2,M1) 
% Toeplitz matrix for 1D periodic structure in the x1 direction or in the x2 direction
q=sqrt(-1);
M=M1;
Epsi=zeros(4*M+1,1);
for m=-2*M:2*M
    if m==0 
       CF=((1/epsilon1)*(l3-l1)+(1/epsilon2)*(l5-l3))/d1;
       Epsi(m+2*M+1)=CF;
    else
       CF=((1/epsilon1)*(exp(-q*2*pi*m*l3/d1)-exp(-q*2*pi*m*l1/d1))/(-2*q*pi*m)+(1/epsilon2)*(exp(-q*2*pi*m*l5/d1)-exp(-q*2*pi*m*l3/d1))/(-2*q*pi*m));
       Epsi(m+2*M+1)=CF;
    end
end
Output=toeplitz(Epsi(2*M+1:4*M+1),Epsi(2*M+1:-1:1));